#include <Servo.h>
#include <Wire.h> 
#include <UltraDistSensor.h>
#include <LiquidCrystal_I2C.h>

LiquidCrystal_I2C lcd(0x3F,16,2); 

//Servomotor stanga
Servo leftServo;

//Servomotor dreapta
Servo rightServo;

//Senzor fata
UltraDistSensor frontSensor;
float frontReading;

//Senzor spate
UltraDistSensor backSensor;
float backReading;

//LED-uri 

// LED ROSU FATA
#define LEDFR PB3 //11

//LED VERDE FATA
#define LEDFV PB0 //8

//LED ROSU SPATE
#define LEDSR PD3 //3

//LED VERDE SPATE
#define LEDSV PD2 //2

// Pentru timpul de asteptare
unsigned long currentMillis;
unsigned long closeTime = 0;

unsigned long currentMillisF;
unsigned long closeTimeF = 0;

void setup()
{
  Serial.begin(9600);
  // Servomotor stanga, pe pinul 9
  leftServo.attach(9);

  // Servomotor dreapta, pe pinul 10
  rightServo.attach(10);
  
  lcd.init();
  lcd.backlight();

  // Senzor spate, trig pin si echo pin pe 12 si 13
  backSensor.attach(12,13);

  // Sensor fata, trig pin si echo pin pe 5 si 6
  frontSensor.attach(5,6);

  //Setare buzzer ca iesire 
  DDRD |= (1 << PD7);

  //Setare LED-uri ca iesiri 

  // LED rosu fata
  DDRB |= (1 << LEDFR);
  // LED verde fata
  DDRB |= (1 << LEDFV);
  // LED rosu spate
  DDRD |= (1 << LEDSR);
  //LED verde spate
  DDRD |= (1 << LEDSV);
  
}

void loop()
{
   backReading = backSensor.distanceInCm();
   frontReading = frontSensor.distanceInCm();
   
   Serial.print("Senzor spate: ");
   Serial.println(backReading);
   
   Serial.print("Senzor fata: ");
   Serial.println(frontReading);
   
   lcd.setCursor(1,0);
   lcd.print("AUTOMATIC DOOR");
   //delay(100);
  
    // Aprindere led-uri verzi
   PORTB |= (1 << LEDFV);
   PORTD |= (1 << LEDSV);
 
   if(backReading < 20 && backReading != 0){
    lcd.setCursor(4,1);
    lcd.print("GOODBYE!");
  
    //LED-ul din fata verde se stinge
    PORTB &= ~(1 << LEDFV);
    // Se aprinde led-ul din fata rosu
    PORTB |= (1 << LEDFR);
    // Se stinge led-ul din spate rosu
    PORTD &= ~(1 << LEDSR);
    // Se aprinde led-ul din spate verde
    PORTD |= (1 << LEDSV);
  
    //se porneste buzzerul
    tone(PD7, 1000);
  
    //se pozitioneaza motoarele cat sa fie usa deschisa
    rightServo.write(1);
    leftServo.write(179);
  
    //dupa 2 secunde jumatate se inchide
    delay(2500);
    
    //motoarele se pozitioneaza pe inchis
    rightServo.write(90);
    leftServo.write(90);
  
    // pe lcd nu se mai afiseaza GOODBYE
    lcd.setCursor(0,1);
    lcd.print("                    ");
  
    //Se opreste buzzerul
    noTone(PD7);
      
    //LED-ul din fata verde se aprinde
    PORTB |= (1 << LEDFV);
    // Se stinge led-ul din fata rosu
    PORTB &= ~(1 << LEDFR);
  }

  if(frontReading < 15 && frontReading != 0){
     lcd.setCursor(4,1);
     lcd.print("WELCOME!");
      
     //LED-ul din fata verde se aprinde
     PORTB |= (1 << LEDFV);
     // Se stinge led-ul din fata rosu
     PORTB &= ~(1 << LEDFR);
     // Se aprinde led-ul din spate rosu
     PORTD |= (1 << LEDSR);
     // Se stinge led-ul din spate verde
     PORTD &= ~(1 << LEDSV);

    //se porneste buzzerul
    tone(PD7, 1000);

    //se pozitioneaza motoarele cat sa fie usa deschisa
    rightServo.write(179);
    leftServo.write(1);

    //dupa 2 secunde jumatate se inchide
    delay(2500);
    //motoarele se pozitioneaza pe inchis
    rightServo.write(90);
    leftServo.write(90);

    // pe lcd nu se mai afiseaza WELCOME
    lcd.setCursor(0,1);
    lcd.print("                    ");

    //Se opreste buzzerul
    noTone(PD7);
    
    //LED-ul din spate verde se aprinde
    PORTD |= (1 << LEDSV);
    // Se stinge led-ul din spate rosu
    PORTD &= ~(1 << LEDSR);
 }
}
